import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;

 /**
  * Contains all information about a
  * calculated dynamical system. This class only consists of a constructor
  * and fields defining the current dynamical system.
  */
public class DynSysInfo
{

   /**
    * The vector of all equations
    */
  public Vector equation_v;
   /**
    * The vector of all starting-values
    */
  public Vector startvalue_v;
   /**
    * Contains either "Extruded Parallel Coordinates", "Linking With Wings",
    * or "Three-dimensional Parallel Coordinates"
    */
  public String method;
   /**
    * Defines the stepwidth used by the algorithm of numerical approximation
    */
  public double stepwidth;
   /**
    * Contains the time-range in textual form
    */
  public String time;
   /**
    * The number of points used in rendering the visualization
    */
  public long   disp_points;

  /**
   * Initializes all the fields empty
   */
  public DynSysInfo ()
  {
    equation_v = new Vector();
    startvalue_v = new Vector();
    method = new String("");
    stepwidth = 0.0;
    time = new String("");
    disp_points = 0;
  }

}


