package data;

import java.awt.*;

/*
 *
 * DataDialogAddDlg
 *
 * Implementiert einen Dialog zur Eingabe von Gleichungen
 *
 */

class DataDialogAddDlg extends Dialog implements Runnable
{
	CheckboxGroup grpType = new CheckboxGroup();
	
	Checkbox chkEquation = new Checkbox( "Equation", grpType, true );
	Checkbox chkHelper = new Checkbox( "Parameter", grpType, false );

	Button btnOk = new Button( "Ok" );
	Button btnCancel = new Button( "Cancel" );

	TextField txtName = new TextField( "x" );
	Label lblName = new Label( "x'=" );
	
	TextField txtEquation = new TextField();

	String sOrigin = "0.0";
	TextField txtOrigin = new TextField( sOrigin, 5 );

	Thread tUpdater;

	DataDialog	parentDialog;

	public DataDialogAddDlg(Frame  parent)
	{
		super( parent, "Add Equation", true );

		parentDialog = (DataDialog)parent;

		resize( 400, 200 );
		// setResizable( false );

		Label lbl;
		Panel pnl;

		setLayout( new BorderLayout() );

		pnl = new Panel();

		GridBagLayout layout = new GridBagLayout();
		GridBagConstraints cons = new GridBagConstraints();

		pnl.setLayout( layout );

		cons.anchor = 	GridBagConstraints.WEST;
		cons.insets = new Insets( 5, 5, 5, 5 );

		// Typ der Gleichung
		lbl = new Label( "Type:" );
		layout.setConstraints( lbl, cons );
		pnl.add( lbl );

		layout.setConstraints( chkEquation, cons );
		pnl.add( chkEquation );

		layout.setConstraints( chkHelper, cons );
		pnl.add( chkHelper );

		// Eingabe des Variablennamens
		lbl = new Label( "Variable:" );
		cons.gridy = 2;
		layout.setConstraints( lbl, cons );
		pnl.add( lbl );

		layout.setConstraints( txtName, cons );
		pnl.add( txtName );

		// Eingabe der Gleichung
		cons.gridy = 3;
		layout.setConstraints( lblName, cons );
		pnl.add( lblName );

		cons.weightx = 1;
		cons.fill = GridBagConstraints.HORIZONTAL;
		cons.gridwidth = 2;
		layout.setConstraints( txtEquation, cons );
		pnl.add( txtEquation );

		// Ursprung fr Iteration
		cons.gridy = 4;
		cons.weightx = 0;
		cons.gridwidth = 1;
		cons.fill = GridBagConstraints.NONE;
		lbl = new Label( "Start:" );
		layout.setConstraints( lbl, cons );
		pnl.add( lbl );

		layout.setConstraints( txtOrigin, cons );
		pnl.add( txtOrigin );

		add( "Center", pnl );

		// Ok, Abbrechen
		pnl = new Panel();
		pnl.setLayout( new GridLayout( 1, 2, 15, 15 ) );

		pnl.add( btnOk );
		pnl.add( btnCancel );

		add( "South", pnl );

		// damit die Felder zusammenarbeiten wird ein
		// eigener Thread gestartet
		tUpdater = new Thread( this );

		tUpdater.start();
		
		// alle Eingabefelder komplett!!!
		show();
	}

	public boolean action( Event evt, Object what ) 
	{
		if( evt.target instanceof Button )
		{
			String str = (String)what;

			if( str.equals( btnOk.getLabel() ) )
			{
				// tUpdater.stop();

				// ist es eine Gleichung oder nur
				// eine Hilfsvariable
				if( chkEquation.getState() )
					parentDialog.addEquation( txtName.getText() + "'",
											  txtEquation.getText(),
											  Double.valueOf(txtOrigin.getText()).doubleValue() );
				else
					parentDialog.addEquation( txtName.getText(),
											  txtEquation.getText(),
											  0.0 );

				hide();
				dispose();
				return true;
			}
			if( str.equals( btnCancel.getLabel() ) )
			{
				// tUpdater.stop();

				hide();
				dispose();
				return true;
			}
		}
		if( (evt.target instanceof Checkbox) &&
			(evt.id == Event.ACTION_EVENT) )
		{
			if( chkEquation.getState() )
			{
				txtOrigin.setEditable( true );
				txtOrigin.setText( sOrigin );
			}
			else
			{
				sOrigin = txtOrigin.getText();
				txtOrigin.setText( "" );
				txtOrigin.setEditable( false );
			}

			return true;
		}

		return false;
	}

	int counter = 0;

    public void run()	
	{
		for(;;)
		{
			String sName = txtName.getText();

			if( sName.length() == 0 ) sName = "x";

			// ist es eine Gleichung oder nur
			// eine Hilfsvariable
			String sType = chkEquation.getState()? "'" : "";

			lblName.setText( sName + sType + "=" );

			try
			{
				Thread.sleep(100);
			}catch( Exception e ) {}
		}
	}
}

