package graphoutput;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;


/**
 * Dialog to choose a color by clicking
 * on a coloured button. Used by several dialogs within this package.
 */
class ColorDlg extends Dialog
implements WindowListener, ActionListener
{                            
  Button target;

   /**
    * Sixteen pre-defined colors, which are selectable.
    */
  public static final Color[] COLOR = {
        new Color(0.3f, 0.6f, 0.1f), new Color(0.0f, 0.0f, 0.5f),
        new Color(0.5f, 0.5f, 0.0f), new Color(0.5f, 0.0f, 0.5f),
        new Color(0.0f, 0.5f, 0.5f), new Color(0.5f, 0.0f, 0.0f),
        new Color(0.0f, 0.5f, 0.0f), new Color(0.25f, 0.25f, 0.25f),
        new Color(0.35f, 0.35f, 0.35f), new Color(0.5f, 0.5f, 0.5f),
        new Color(0.2f, 0.2f, 0.6f), new Color(0.6f, 0.4f, 0.1f) ,
        new Color(0.6f, 0.1f, 0.3f), new Color(0.0f, 0.0f, 0.0f) ,
        new Color(0.6f, 0.4f, 0.6f), new Color(0.7f, 0.7f, 0.7f) };


   /**
    * Fills the frame with sixteen differently colored buttons
    */
  public ColorDlg(Frame parent, Button target)
  {
	super( parent, "Choose a color", true );

    // create the color-buttons
    setLayout(new GridLayout(4,4));

    for (int i=0; i<16; i++)
    {
      Button b = new Button("");
      b.setBackground(COLOR[i]);
      b.addActionListener(this);
      add(b);
    }

    this.target = target;
    pack();
    addWindowListener(this);
    setVisible(true);
  }

   /**
    * Fills the frame with sixteen differently colored buttons
    */
  public ColorDlg(Dialog parent, Button target)
  {
	super( parent, "Choose a color", true );

    // create the color-buttons
    setLayout(new GridLayout(4,4));

    for (int i=0; i<16; i++)
    {
      Button b = new Button("");
      b.setBackground(COLOR[i]);
      b.addActionListener(this);
      add(b);
    }

    this.target = target;
    pack();
    addWindowListener(this);
    setVisible(true);
  }


   /**
    * Handles the action for a pressed button (=selected color).
    */
  public void actionPerformed(ActionEvent e)
  {
	if(e.getSource() instanceof Button)
    {
      target.setBackground(((Button)e.getSource()).getBackground());
      setVisible(false);
      dispose();
    }
  }

    public void windowActivated(WindowEvent e) {}
    public void windowClosed(WindowEvent e) {}
    public void windowClosing(WindowEvent e)
	{
      setVisible(false);
	  dispose();
	}
    public void windowDeactivated(WindowEvent e) {}
    public void windowDeiconified(WindowEvent e) {}
    public void windowIconified(WindowEvent e) {}
    public void windowOpened(WindowEvent e) {}

}

