package graphoutput;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import DynSysInfo;


/**
 * Dialog to show the properties of a Dynamical
 * System by extracting the information from DynSysInfo
 */
class DSInfoDlg extends Frame
implements WindowListener
{
   /**
    * Fills the information provided by the parameter into the frame
    */
	public DSInfoDlg( DynSysInfo dsi )
	{
		super( "Properties" );

		setLayout( new GridLayout(dsi.equation_v.size()+3,1) );

        Label la = new Label( "[Starting Value] Equations", Label.LEFT );
        la.setBackground( Color.lightGray );
        la.setFont(new Font("Dialog", Font.BOLD, 12));
        add(la);

        Font f = new Font("Dialog", Font.PLAIN, 10);
        for (int i=0; i<dsi.equation_v.size(); i++)
        {
          String s = new String();
          if( i<dsi.startvalue_v.size() )
            s = new String("[" + ((Double)dsi.startvalue_v.elementAt(i)) + "]  ");
          else
            s = new String("");
          Label l = new Label( s + ((String)dsi.equation_v.elementAt(i)), Label.LEFT );
          l.setBackground (Color.lightGray);
          l.setFont(f);

          add(l);
        }

        la = new Label("Time: " + dsi.time + "  Stepwidth = "+dsi.stepwidth);
        la.setBackground (Color.white);
        la.setFont(f);
        add(la);
        la = new Label("Method: " + dsi.method + "    "+dsi.disp_points+" Displayed Points");
        la.setBackground (Color.white);
        la.setFont(f);
        add(la);

        pack();
		addWindowListener(this);
	}

    public void windowActivated(WindowEvent e) {}
    public void windowClosed(WindowEvent e) {}
    public void windowClosing(WindowEvent e)
	{
      setVisible(false);
	  dispose();
	}
    public void windowDeactivated(WindowEvent e) {}
    public void windowDeiconified(WindowEvent e) {}
    public void windowIconified(WindowEvent e) {}
    public void windowOpened(WindowEvent e) {}


}

